mod Ul05 logic: 'cl'

incl Mtex

incl Mtexln

incl Maux

loc rem 
  \para \bf  PRÉMIOVA ÚLOHA Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 12.81.21 
  \para* \it  Dátum:  \end pondelok 18.5.2015 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1415ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohu: \bf  \it  8  \end  \end. 
   \item \para Úlohy riešte \bf  \it  samostatne!  \end  \end 
  \end
  \para Úlohu treba odovzdať do 26.5.2015 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Downloadable lecture notes available through the web page of 
         the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Sorting of Lists.  \end 

rem 
  \para \bf  [CL] Remark.  \end See the auxiliary module \it  Maux*  \end. 

rem 
  \para \bf  Subsection. Merge Sort.  \end 

rem 
  \para \bf  [CL] Remark.  \end Below we will use the discrimination on whether 
  or not \ft L(x) <= 1 \end. As we have 
  \eq* 
    L(x) <= 1 <-> Tex_f1_pp_proj2(x) = 0
  \end
  \para we may suppose that the test \ft L(x) <= 1 \end takes constant time. 

rem 
  \para \bf  Splitting the list into two halves.  \end 

fun Msplit 
  Msplit(x) = x,0 <- L(x) <= 1
  Msplit(x) = (u,y),v,z <- L(x) > 1 & x = u,v,w & Msplit(w) = y,z

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    \e y\e z Msplit(x) = y,z
  \end
  \eq* 
    Msplit(x) = y,z -> Perm(x,y++z)
  \end
  \eq* 
    Msplit(x) = y,z -> L(y) = L(z) \/ L(y) = L(z)+1
  \end

thm Msplit_output
  \e y\e z Msplit(x) = y,z

lemma Lemma_msplit_perm
  Perm(w,y++z) -> Perm((u,v,w),u,y++(v,z))
proof 
 use Perm_cancel_conc_elem.0; u,0; v; w; u,y; z
  weak Perm((u,v,w),u,y++(v,z)) <-> Perm((u,w),u,y++z)
   use Perm_pair; w; y++z; u proved....

thm Msplit_perm
  Msplit(x) = y,z -> Perm(x,y++z)

thm Msplit_l_half
  Msplit(x) = y,z -> L(y) = L(z) \/ L(y) = L(z)+1

rem 
  \para \bf  Merging two ordered lists into one.  \end 

fun/2 Merge 
  Merge(0,y) = y
  Merge((v1,w1),0) = v1,w1
  Merge((v1,w1),v2,w2) = v1,Merge(w1,v2,w2) <- v1 <= v2
  Merge((v1,w1),v2,w2) = v2,Merge((v1,w1),w2) <- v1 > v2

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Perm(Merge(x,y),x++y)
  \end
  \eq* 
    Ord(x) & Ord(y) -> Ord Merge(x,y)
  \end

lemma Lemma_merge_perm
  Perm(m,v1,w1++w2) -> Perm((v2,m),v1,w1++(v2,w2))
proof 
 use Perm_cancel_conc_elem.0; 0; v2; m; v1,w1; w2 proved..

thm Merge_perm
  Perm(Merge(x,y),x++y)

thm Merge_ord
  Ord(x) & Ord(y) -> Ord Merge(x,y)

rem 
  \para \bf  Merge sort.  \end 

fun Msort 
  Msort(x) = x <- L(x) <= 1
  Msort(x) = Merge(Msort(y),Msort(z)) <- L(x) > 1 & Msplit(x) = y,z

rem 
  \para \bf  Exercise.  \end Prove the condition of regularity for the function 
  \ft Msort(x) \end: 
  \eq* 
    L(x) > 1 & Msplit(x) = y,z -> L(y) < L(x) & L(z) < L(x)
  \end

thm Condition_of_regularity_for_msort
  L(x) > 1 & Msplit(x) = y,z -> L(y) < L(x) & L(z) < L(x)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Perm(Msort(x),x)
  \end
  \eq* 
    Ord Msort(x)
  \end

lemma Lemma_msort_perm
  Perm(m,y1++z1) & Perm(y1,y) & Perm(z1,z) & Perm(x,y++z) -> Perm(m,x)
proof 
 use Perm_trans; m; y1++z1; x
  use Perm_conc; y1; y; z1; z
   use Perm_trans; y1++z1; y++z; x
    use Perm_sym; x; y++z proved.....

thm Msort_perm
  Perm(Msort(x),x)

thm Msort_ord
  Ord Msort(x)

